package googlesearch;

import java.util.List;

/*
 * Created on Apr 12, 2006
 * 
 * @author jbergin
 *
 */

/** A query that will find all the words in two previously created queries. "Joseph" AND "Bergin"
 * @author jbergin
 *
 */
public class AndQuery extends CompositeQuery
{
	/** Create an AND query. To find all the words in two given queries: left AND right
	 * @param left the query to the left of the AND logical operator
	 * @param right the query to the right of the and operator
	 */
	public AndQuery(Query left, Query right)
	{
		this.left = left;
		this.right = right;
	}
	
	public String buildSearchString(List<Query> start, List<Query> finish)
	{
		String leftString = left.buildSearchString(start, finish);
		String rightString = right.buildSearchString(start, finish);
		return leftString + " " + rightString;
	}
	
	private final Query left;
	private final Query right;
}
