/*
 * Created on Apr 15, 2006
 * 
 * @author jbergin
 *
 */
package googlesearch;

import java.util.List;

/** Generate a query that will search for definitions of the phrase of a base query. Note that this only makes sense
 * for a simple query. It is automatically exact. 
 * @author jbergin
 *
 */
public class DefinitionQuery extends CompositeQuery
{
    public DefinitionQuery(Query baseQuery)
    {
        this.decorated = baseQuery;
    }

    public String buildSearchString(List<Query> start, List<Query> finish)
    {
        String decoratedString = decorated.buildSearchString(start, finish);
        decoratedString = ExactQuery.stripQuotes(decoratedString);
        start.add(this);
        return decoratedString;
    }
    
    public String modifier()
    {
        return "define: ";
    }
    
    private final Query decorated;
}
