/*
 * Created on Apr 15, 2006
 * 
 * @author jbergin
 *
 */
package googlesearch;

import java.util.ArrayList;

import junit.framework.TestCase;
import junit.framework.TestSuite;

/** A simple JUnit test for the DefinitionQuery class. As supplied it is incomplete. 
 * @author jbergin
 *
 */
public class DefinitionQueryTest extends TestCase
{
    Query query;
    String karel = "karel";
    
    protected void setUp() throws Exception
    {
        super.setUp();
        Query left = new SimpleQuery(karel);
        query = new DefinitionQuery(left);
    }

    /*
     * Test method for 'googlesearch.DefinitionQuery.buildSearchString(List<Query>, List<Query>)'
     */
    public void testBuildSearchString()
    {
        ArrayList<Query> pre = new ArrayList<Query>();
        ArrayList<Query> post = new ArrayList<Query>();
        String result = query.buildSearchString(pre,post);
        assertEquals(karel, result);
        assertEquals(query, pre.get(0));
        assertEquals(0, post.size());
        assertEquals(1, pre.size());
    }

    /*
     * Test method for 'googlesearch.DefinitionQuery.modifier()'
     */
    public void testModifier()
    {
        assertEquals("define: ", query.modifier());
    }

    /*
     * Test method for 'googlesearch.CompositeQuery.getSearchString()'
     */
    public void testGetSearchString()
    {
        assertEquals("define: "+karel, query.getSearchString());
    }

    public void testGetSearchStringAdvanced()
    {
        Query more = new SimpleQuery("test");
        Query another = new AndQuery(more, query);
        assertEquals("define: test "+ karel, another.getSearchString());
        another = new AndQuery( query, more);
        assertEquals("define: "+ karel+" test", another.getSearchString());
    }

   public static TestSuite suite()
    {
        return new TestSuite(DefinitionQueryTest.class);
    }
}
