/*
 * Created on Apr 15, 2006
 * 
 * @author jbergin
 *
 */
package googlesearch;

import junit.framework.TestCase;
import junit.framework.TestSuite;
import java.util.ArrayList;

/** A simple JUnit test for the SiteQuery class. As supplied it is incomplete. 
 * @author jbergin
 *
 */
public class SiteQueryTest extends TestCase
{
    Query query;
    String baseString = "www.google.com";
    protected void setUp() throws Exception
    {
        super.setUp();
        Query base = new SimpleQuery("search");
        query = new SiteQuery(base, baseString);
    }

    /*
     * Test method for 'googlesearch.SiteQuery.buildSearchString(List<Query>, List<Query>)'
     */
    public void testBuildSearchString()
    {
        ArrayList<Query> pre = new ArrayList<Query>();
        ArrayList<Query> post = new ArrayList<Query>();
        String result = query.buildSearchString(pre,post);
        assertEquals("search", result);
        assertEquals(query, post.get(0));
        assertEquals(1, post.size());
        assertEquals(0, pre.size());
    }

    /*
     * Test method for 'googlesearch.SiteQuery.modifier()'
     */
    public void testModifier()
    {
        assertEquals(" site:"+baseString, query.modifier());
    }

    /*
     * Test method for 'googlesearch.SiteQuery.validateSite(String)'
     */
    public void testValidateSite()
    {
        assertTrue(SiteQuery.validateSite("www.google.com"));
    }

    /*
     * Test method for 'googlesearch.CompositeQuery.getSearchString()'
     */
    public void testGetSearchString()
    {
        assertEquals("search site:"+baseString, query.getSearchString());
    }

    public void testGetSearchStringAdvanced()
    {
        Query another = new SimpleQuery("test");
        Query more = new AndQuery(query, another);
        assertEquals("search test site:"+baseString, more.getSearchString());
        more = new AndQuery(another, query);
        assertEquals("test search site:"+baseString, more.getSearchString());
    }
    
    public void testGetSearchStringSecondSite()
    {
        query = new SiteQuery( query, "foo.com"); // ignore second site
        assertEquals("search site:"+baseString, query.getSearchString());       
    }

    public static TestSuite suite()
    {
        return new TestSuite(SiteQueryTest.class);
    }
}
